pro compute_offsets, file_scalars, off, ind_scans=ind_scans, ind_subscans=ind_subscans, maxnoise=maxnoise, $
                     galactic=galactic



;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


restore, file_scalars

restore, file_signal

med_wn_tot = median(maxnoise)


off = fltarr(nscans, nb)

for s = 0, nscans - 1 do begin
   wsubs = where(ind_subscans ge ind_scans(s) and ind_subscans lt ind_scans(s+1) - 1)
   nt_scan = ind_scans(s+1) - ind_scans(s)
   wb = where(total(finite(maxnoise(wsubs, *)), 1) gt 0 and total(finite(signal(ind_scans(s):ind_scans(s+1)-1, *)), 1) gt nt_scan / 5L, cb)
   off(s, wb) = median(signal(ind_scans(s):ind_scans(s+1)-1, wb), dimension=1)

   if keyword_set(galactic) then if cb ge 10L then begin
      sig = signal(ind_scans(s):ind_scans(s+1)-1, wb)
      min_sb = min(sig, /nan)
      w = where(finite(sig) lt 1, cw)
      if cw ge 1 then sig(w) = min_sb - 100.
      med_wn = min([med_wn_tot / 3., median(maxnoise(wsubs, *)) / 3.])
      h2 = hist_2d(sig, findgen(cb) ## (1. + fltarr(nt_scan)), min1=min_sb, bin1=med_wn)
      n_bin = n_elements(h2(*, 0))
      sb = min_sb + med_wn * findgen(n_bin)
      m = max(h2, dimension=1, ind)
      off(s, wb) = min([[sb(ind mod n_bin)], [median(signal(ind_scans(s):ind_scans(s+1)-1, wb), dimension=1)]], dimension=2)
   endif
endfor


end
