pro stat_map_artemis, med, sig, map=map, weightmap=weightmap, noise_level=noise_level, use_map_back=use_map_back


;;; estimates an approximate background level and dispersion of an image
;;; (used to define source masks)

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



save_weightmap = weightmap

thres_weight = 0.
wdef = where(weightmap gt thres_weight and finite(map) gt 0, cw)
n_valid = cw
ind_sort = sort(map(wdef))
sb_min = map(wdef(ind_sort(cw/1000L)))
sb_max = map(wdef(ind_sort(cw-1-cw/100L)))
w = where(weightmap gt thres_weight and finite(map) gt 0 and map ge sb_min and map le sb_max)
binsize = max([noise_level / 10., (max(map(w)) - min(map(w))) / 1000.])
binsize = min([binsize, (max(map(w)) - min(map(w))) / 100.])
histo = histogram(map(w), locations=sb, binsize=binsize)

m = max(histo, ind)
w = where(histo gt m / 30., cw)
med = sb(w(0))
if sb(ind) - med le 10. * (Machar()).eps then lim = sb(w(cw-1)) else lim = sb(ind)
w = where(weightmap gt thres_weight and map le lim and map ge med)
sig = sqrt(mean((map(w) - med)^2.))
if sig lt 100. * noise_level then for k = 0, 9 do begin
   if sig gt 10. * (Machar()).eps then begin
      w = where(weightmap gt thres_weight and map - med le 2. * sig)
      histo = histogram(map(w), locations=sb, binsize=binsize)
      m = max(histo, ind)
      wpl = where(histo ge 0.3 * m)
      med = min(sb(wpl)) - binsize
      wlim = where(histo gt m / 30., cw)
      if med - sb(wlim(0)) le 10. * (Machar()).eps then lim = sb(wlim(cw-1)) else lim = med
      w = where(weightmap gt thres_weight and map le lim and map ge sb(wlim(0)))
      sig = sqrt(mean((map(w) - med)^2.))
      w = where(weightmap gt thres_weight and map - med le 2.5 * sig)
      med = median(map(w), /even)
      w = where(weightmap gt thres_weight and abs(map - med) lt 2.5 * sig)
      sig = sqrt(mean((map(w) - med)^2.))

      ;;; apply a cut to bright sources:
      if k eq 2 then begin
         if keyword_set(use_map_back) then begin
            wz = where(finite(use_map_back) lt 1, cz)
            if cz ge 1 then weightmap(wz) = 0.
         endif else begin
            w = where(weightmap gt thres_weight and finite(map) gt 0, cw)
            histo = histogram(map(w), locations=sb, binsize=binsize)
            w = where(histo ge max(histo) / 30., cw)
            sb_min = sb(w(0))
            range = sb(w(cw-1)) - sb_min
            thres = 2.5 * (med - sb_min)
            if range gt thres then begin
               wz = where(map gt sb_min + thres, cz)
               if cz gt n_valid / 4L then begin
                  ind = sort(map(wz))
                  wz = wz(ind(cz-n_valid/4L:cz-1L))
               endif
               if cz ge 1 then weightmap(wz) = 0.
            endif
         endelse
      endif

   endif else sig = noise_level
endfor else sig = 10. * noise_level

weightmap = save_weightmap

end
