pro visu_arrays, file_scalars=file_scalars, ind_scans=ind_scans, elec_boxes=elec_boxes


;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


restore, file_scalars

window, 26, xs=800, ys=800
load_mapcol

restore, file_pixcoords
restore, file_signal

tab_col = [100, 150, 55, 7, 200, 30, 120, 230, 70, 3, 240, 135, 85, 165, 20, 40]


wset, 26
boxes_prev = 0
num_config = 1
for s = 0, nscans - 1 do begin
   wb = where(total(finite(signal(ind_scans(s):ind_scans(s+1)-1, *)), 1) gt (ind_scans(s+1) - ind_scans(s)) / 2L)
   boxes = reform(elec_boxes(s, wb))
   if (max(abs(boxes - boxes_prev)) gt 0 or s eq 0) then begin
      nbox = round(max(boxes) - min(boxes(where(boxes ge 0)))) + 1
      x = pix_as * reform(x_bolos(ind_scans(s)+100, wb))
      x -= median(x, /even)
      y = pix_as * reform(y_bolos(ind_scans(s)+100, wb))
      y -= median(y, /even)
      xrange = [1.1 * min(x), 1.1 * max(x)]
      yrange = [1.1 * min(y), 1.1 * max(y)]
      xyrange = [min([xrange(0), yrange(0)]), max([xrange(1), yrange(1)])]
      otherplot, x, y, psym=6, xtitle='dx (arcsec)', ytitle='dy (arcsec)', xrange=xyrange, yrange=xyrange, $
         title='configuration ' + chain(num_config)
      for i = 0, nbox - 1 do begin
         wbox = where(boxes - min(boxes(where(boxes ge 0))) eq i, cbox)
         if cbox ge 1 then otherplot, /over, x(wbox), y(wbox), psym=6, color=tab_col(i)
      endfor
      res = dialog_message('   Continue ?   ', /center, /information, title='Pause')
      num_config += 1
   endif
   boxes_prev = boxes
endfor
loadct, 15

end
