pro format_input_scanam_artemis, dir_out=dir_out, list_scannum=list_scannum, array=array, append=append



;;; wrapper for the conversion of "level-1" xdr files into Scanamorphos input structures,
;;; for ArT\'eMiS

;;; to be used for all scans of a mosaic


;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



resolve_all, /continue_on_error, /quiet


nscans = n_elements(list_scannum)

if (not keyword_set(array)) then array = 350

if (not keyword_set(dir_out)) then begin
   dir_out = ''
   print, ''
   print, 'The output directory (where input structures will be written) is mandatory.'
   repeat read, dir_out, prompt='   dir_out=' until dir_out ne ''
endif
res = file_search(dir_out, /fold_case, /test_write, /fully_qualify_path, count=ndir)
if ndir ne 1 then begin
   print, ''
   print, 'Check output directory name and make sure to have write permission in it.'
   return
endif else dir_out = res
nc = strlen(dir_out)
if strmid(dir_out, nc-1) ne '/' then dir_out = dir_out + '/'


file_scanlist = 'scanlist_artemis'
if keyword_set(append) then openu, 8, dir_out + file_scanlist, /append else begin
   openw, 8, dir_out + file_scanlist
   printf, 8, format='(A)', dir_out
endelse

for s = 0, nscans - 1 do begin
   scannum = list_scannum(s)
   file_scan = 'stru_' + chain(scannum) + '_' + chain(array) + '.xdr'
   convert_input_subscans_artemis, dir_out=dir_out, scannum=scannum, file_scan=file_scan, array=array
   printf, 8, format='(A)', file_scan
endfor

close, 8


end
